aboutsummaryrefslogtreecommitdiffstats
path: root/osmo-release.sh
diff options
context:
space:
mode:
authorDaniel Willmann <dwillmann@sysmocom.de>2018-08-31 17:35:54 +0200
committerDaniel Willmann <dwillmann@sysmocom.de>2018-08-31 17:35:54 +0200
commite373a09becac632161bb69aa0373fdf41da27b8a (patch)
tree83b3f579a6762bcfdd903f5d5c5c8415e854ee47 /osmo-release.sh
parentf9f7e016e84f8e0e88692dbd0aa0582794190eb8 (diff)
parent1a72bafa5df03718bb1c328f3d64078dc5e70feb (diff)
Merge remote-tracking branch 'origin/master' into daniel/onwaves
Diffstat (limited to 'osmo-release.sh')
-rwxr-xr-xosmo-release.sh48
1 files changed, 44 insertions, 4 deletions
diff --git a/osmo-release.sh b/osmo-release.sh
index 86b41d89..4d4d080b 100755
--- a/osmo-release.sh
+++ b/osmo-release.sh
@@ -4,11 +4,23 @@ REL=$2
if [ "z$REL" = "z" ]; then
echo "No REL value specified, defaulting to 'patch' release"
- REL=patch
+ REL="patch"
fi
-BUMPVER=`command -v bumpversion`
+ALLOW_NO_LIBVERSION_CHANGE="${ALLOW_NO_LIBVERSION_CHANGE:-0}"
+ALLOW_NO_LIBVERSION_DEB_MATCH="${ALLOW_NO_LIBVERSION_DEB_MATCH:-0}"
+
+libversion_to_deb_major() {
+ libversion="$1"
+ current="$(echo "$libversion" | cut -d ":" -f 1)"
+ #revision="$(echo "$libversion" | cut -d ":" -f 2)"
+ age="$(echo "$libversion" | cut -d ":" -f 3)"
+ major="$(expr "$current" - "$age")"
+ echo "$major"
+}
+BUMPVER=`command -v bumpversion`
+GIT_TOPDIR="$(git rev-parse --show-toplevel)"
NEW_VER=`bumpversion --list --current-version $VERSION $REL --allow-dirty | awk -F '=' '{ print $2 }'`
LIBVERS=`git grep -n LIBVERSION | grep '=' | grep am | grep -v LDFLAGS`
MAKEMOD=`git diff --cached -GLIBVERSION --stat | grep Makefile.am`
@@ -27,12 +39,40 @@ fi
echo "Releasing $VERSION -> $NEW_VER..."
if [ "z$LIBVERS" != "z" ]; then
- if [ "z$MAKEMOD" = "z" ]; then
- echo "Before releasing, please modify some of the libversions: $LIBVERS"
+ if [ "z$MAKEMOD" = "z" ] && [ "z$ALLOW_NO_LIBVERSION_CHANGE" = "z0" ]; then
+ echo "ERROR: Before releasing, please modify some of the libversions: $LIBVERS"
echo "You should NOT be doing this unless you've read and understood following article:"
echo "https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html#Updating-version-info"
exit 1
fi
+ if [ "z$ALLOW_NO_LIBVERSION_DEB_MATCH" = "z0" ]; then
+ echo "$LIBVERS" | while read -r line; do
+ libversion=$(echo "$line" | cut -d "=" -f 2)
+ major="$(libversion_to_deb_major "$libversion")"
+ file_matches="$(find "${GIT_TOPDIR}/debian" -name "lib*${major}.install" | wc -l)"
+ if [ "z$file_matches" = "z0" ]; then
+ echo "ERROR: Found no matching debian/lib*$major.install file for LIBVERSION=$libversion"
+ exit 1
+ elif [ "z$file_matches" = "z1" ]; then
+ echo "OK: Found matching debian/lib*$major.install for LIBVERSION=$libversion"
+ else
+ echo "WARN: Found $file_matches files matching debian/lib*$major.install for LIBVERSION=$libversion, manual check required!"
+ fi
+ control_matches="$(grep -e "Package" "${GIT_TOPDIR}/debian/control" | grep "lib" | grep "$major$" | wc -l)"
+ if [ "z$control_matches" = "z0" ]; then
+ echo "ERROR: Found no matching Package lib*$major in debian/control for LIBVERSION=$libversion"
+ exit 1
+ elif [ "z$control_matches" = "z1" ]; then
+ echo "OK: Found 'Package: lib*$major' in debian/control for LIBVERSION=$libversion"
+ else
+ echo "WARN: Found $file_matches files matching 'Package: lib*$major' in debian/control for LIBVERSION=$libversion, manual check required!"
+ fi
+ done
+ # catch and forward exit from pipe subshell "while read":
+ if [ $? -ne 0 ]; then
+ exit 1
+ fi
+ fi
if [ -f "TODO-RELEASE" ]; then
grep '#' TODO-RELEASE > TODO-RELEASE.clean
mv TODO-RELEASE.clean TODO-RELEASE